<?php



function web_connector__config__update() {
    
    web_connector__console_log('web-connector-common.php');
    web_connector__console_log('web_connector__config__update()');

    // WARN must be here not outside
    $log__file_path = __DIR__ . '/../../../' . 'web-connector.log';
    // mazať je fajn avšak nie viem potom použiť "tail"
    // if (file_exists($log__file_path)) {
    //     unlink($log__file_path);
    // }
    file_put_contents($log__file_path, '');

    // get settings
    $config__file_path = __DIR__ . '/' . 'web-connector-config.php';
    web_connector__console_log($config__file_path);
    include $config__file_path;
    web_connector__console_log($setting__array);
    web_connector__console_log($app_version);
    web_connector__console_log($url_key);
    web_connector__console_log($fs_path_root);

    $plugin_data = get_plugin_data(__FILE__);
    $plugin_version = $plugin_data['Version'];
    web_connector__console_log($plugin_version);
    web_connector__console_log($app_version != $plugin_version);
    if ($app_version != $plugin_version) {
        
        $setting__array['app_version'] = $plugin_version;
        $setting__array['url_key'] = $url_key;
        $setting__array['fs_path_root'] = $fs_path_root;

        $setting__json_string = json_encode($setting__array, JSON_PRETTY_PRINT);
        web_connector__console_log($setting__json_string);

        $settings__file_php = '
<?php

$settings_json = \'' . $setting__json_string . '\';

?>
';
        // web_connector__console_log($settings__file_php);
        $settings__file_path = __DIR__ . '/../../../' . 'web-connector-setting.php';
        file_put_contents($settings__file_path, $settings__file_php);
    }
    
}



/**
* Show a notice to anyone who has just updated this plugin
* This notice shouldn't display to anyone who has just installed the plugin for the first time
*/
function web_connector__display_update_notice() {

    $plugin_data = get_plugin_data(__FILE__);
    $plugin_name = $plugin_data['Name'];

    // Check the transient to see if we've just updated the plugin
    if( get_transient( 'web_connector__updated' ) ) {
        echo '<div class="notice notice-success"><p>' . __( 'Thanks for updating ' . $plugin_name . '.', 'web_connector' ) . '</p></div>';
        delete_transient( 'web_connector__updated' );
    }

}
add_action( 'admin_notices', 'web_connector__display_update_notice' );
/**
* This function runs when WordPress completes its upgrade process
* It iterates through each plugin updated to see if ours is included
* @param $upgrader_object Array
* @param $options Array
*/
// https://codex.wordpress.org/Plugin_API/Action_Reference/upgrader_process_complete
function web_connector__upgrade_completed( $upgrader_object, $options ) {
    // The path to our plugin's main file
    $our_plugin = plugin_basename( __FILE__ );
    // If an update has taken place and the updated type is plugins and the plugins element exists
    if( $options['action'] == 'update' && $options['type'] == 'plugin' && isset( $options['plugins'] ) ) {
        // Iterate through the plugins being updated and check if ours is there
        foreach( $options['plugins'] as $plugin ) {
            if( $plugin == $our_plugin ) {
                
                web_connector__config__update();
                
                // Set a transient to record that our plugin has just been updated
                set_transient( 'web_connector__updated', 1 );
                
            }
        }
    }
}
add_action( 'upgrader_process_complete', 'web_connector__upgrade_completed', 10, 2 );



//// WARN generuje mi tento err
//// The plugin generated X characters of unexpected output during activation
//// https://stackoverflow.com/a/4074549/1347601
/**
* Show a notice to anyone who has just installed the plugin for the first time
* This notice shouldn't display to anyone who has just updated this plugin
*/
// function web_connector__display_install_notice() {

//     $plugin_data = get_plugin_data(__FILE__);
//     $plugin_name = $plugin_data['Name'];

//     // Check the transient to see if we've just activated the plugin
//     if( get_transient( 'web_connector__activated' ) ) {
//         echo '<div class="notice notice-success"><p>' . __( 'Thanks for using ' . $plugin_name . '.', 'web_connector' ) . '</p></div>';
//         // Delete the transient so we don't keep displaying the activation message
//         delete_transient( 'web_connector__activated' );
//     }

// }
// add_action( 'admin_notices', 'web_connector__display_install_notice' );
/**
* Run this on activation
* Set a transient so that we know we've just activated the plugin
*/
//// https://developer.wordpress.org/plugins/plugin-basics/activation-deactivation-hooks
//// https://developer.wordpress.org/reference/functions/register_activation_hook
function web_connector__activate() {
    web_connector__config__update();
    // // Set a transient to record that our plugin has just been updated
    // set_transient( 'web_connector__activated', 1 );
}
register_activation_hook( __FILE__, 'web_connector__activate' );



/**
* How to integrate WordPress Core updates with your custom Plugin or Theme
* 
* Filter the `update_plugins` transient to report your plugin as out of date.
* Themes have a similar transient you can filter.
*/
// https://gist.github.com/danielbachhuber/7684646
function web_connector__plugin_update( $update_plugins ) {
    
    web_connector__console_log('web_connector__plugin_update()');
    
	if ( ! is_object( $update_plugins ) ) {
		return $update_plugins;
	}
	
	if ( ! isset( $update_plugins->response ) || ! is_array( $update_plugins->response ) ) {
		$update_plugins->response = array();
	}
	
	// info.json is the file with the actual plugin information on your server
	$remote = wp_remote_get(
	    'https://webcloud.io/downloads/web-connector/info.json',
	    array(
			'timeout' => 10,
			'headers' => array(
				'Accept' => 'application/json'
			)
		)
	);
	
	if( $remote ) {

        // contain html not json - means error - so don't show wp update info
        if(strpos($remote['body'], 'html') !== false) {
            return null;
        }
        
		$remote = json_decode( $remote['body'] );
		
		$plugin_info = get_plugin_data(plugin_dir_path(__FILE__) . 'web-connector.php');
		$plugin_version_current = $plugin_info["Version"];
		
		if( $remote->version != $plugin_version_current ) {
        	
        	$update_plugins->response['web-connector/web-connector.php'] = (object)array(
    			'slug'         => 'web-connector', // Whatever you want, as long as it's not on WordPress.org
    			'new_version'  => $remote->version, // The newest version
    			'url'          => 'https://webcloud.io/downloads/web-connector', // Informational
    			'package'      => $remote->download_url, // Where WordPress should pull the ZIP from.
        	);
        	
		}
    	
	}
	
	return $update_plugins;
	
}
// add_filter( 'site_transient_update_plugins', 'web_connector__plugin_update' );
add_filter( 'transient_update_plugins', 'web_connector__plugin_update' );



//// TASK add ešte že po deactiation
// session_destroy();


?>